/****************************************************************************
  SH7262 VDC3 VGA & SVGAeXg(768hbg܂ł\łȂH)
****************************************************************************/

#include "cpu.h"
#include "cpu_init.h"
#include "cpu_uart.h"
#include "tinylib.h"


/* AiORGB(VGA) */
#define LCDv_HORIZONTAL_PERIOD         (800)	/*  */
#define LCDv_HORIZONTAL_DISPLAY_PERIOD (640)	/* \ */
#define LCDv_HORIZONTAL_BACK_PORCH     (130)	/* obN|[` */
#define LCDv_HORIZONTAL_PULSE_WIDTH    ( 95)	/*  */
#define LCDv_VERTICAL_PERIOD           (524)	/*  */
#define LCDv_VERTICAL_DISPLAY_PERIOD   (480)	/* \ */
#define LCDv_VERTICAL_BACK_PORCH       ( 34)	/* obN|[` */
#define LCDv_VERTICAL_PULSE_WIDTH      (  2)	/*  */

/* AiORGB(SVGA) */
#define LCDz_HORIZONTAL_PERIOD         (1023)	/*  */
#define LCDz_HORIZONTAL_DISPLAY_PERIOD (800)	/* \ */
#define LCDz_HORIZONTAL_BACK_PORCH     (160)	/* obN|[` */
#define LCDz_HORIZONTAL_PULSE_WIDTH    ( 60)	/*  */
#define LCDz_VERTICAL_PERIOD           (655)	/*  */
#define LCDz_VERTICAL_DISPLAY_PERIOD   (600)	/* \ */
#define LCDz_VERTICAL_BACK_PORCH       ( 40)	/* obN|[` */
#define LCDz_VERTICAL_PULSE_WIDTH      (  5)	/*  */

/* AiORGB(SVGA) */
#define LCDs_HORIZONTAL_PERIOD         (1023)	/*  */
#define LCDs_HORIZONTAL_DISPLAY_PERIOD (768)	/* \ */
#define LCDs_HORIZONTAL_BACK_PORCH     (170)	/* obN|[` */
#define LCDs_HORIZONTAL_PULSE_WIDTH    ( 80)	/*  */
#define LCDs_VERTICAL_PERIOD           (655)	/*  */
#define LCDs_VERTICAL_DISPLAY_PERIOD   (600)	/* \ */
#define LCDs_VERTICAL_BACK_PORCH       ( 40)	/* obN|[` */
#define LCDs_VERTICAL_PULSE_WIDTH      (  5)	/*  */

/* OtBbN1(VGA) */
#define GRA1v_HORIZONTAL_SIZE          (640)	/* \TCY */
#define GRA1v_VERTICAL_SIZE            (480)	/* \TCY */
#define GRA1_HORIZONTAL_POS             0		/* \ʒu */
#define GRA1_VERTICAL_POS               0		/* \ʒu */
#define GRA1_VRAM_BASE         0x3C000000		/* eʓRAM y[W0` */

/* OtBbN1(SVGA) */
#define GRA1s_HORIZONTAL_SIZE          (800)	/* \TCY */
#define GRA1s_VERTICAL_SIZE            (600)	/* \TCY */


/* VGA\eXg */
void VDC3_VGA(void)
{
	int i, j, l;
	unsigned short int *gra_vram;

	/* \䕔  */
	*SGMODE           = 0x00000001;
	*SYNCNT           = 0x010F000C;
	*PANEL_CLKSEL     = *PANEL_CLKSEL & ~(1 << 12);
//	*PANEL_CLKSEL     = 0x00002008;		/* 6MHz(48MHz / 8)  6.4MHz(typ) */
	*PANEL_CLKSEL     = 0x00002002;		/* 24MHz(48MHz / 2) */
	*PANEL_CLKSEL     = *PANEL_CLKSEL | (1 << 12);
	*SYN_SIZE         = (LCDv_VERTICAL_PERIOD << 16) | (LCDv_HORIZONTAL_PERIOD);
	*PANEL_VSYNC_TIM  = (0 << 16) | (LCDv_VERTICAL_PULSE_WIDTH);
	*PANEL_HSYNC_TIM  = (0 << 16) | (LCDv_HORIZONTAL_PULSE_WIDTH);
	*DE_SIZE          = (LCDv_VERTICAL_DISPLAY_PERIOD << 16) | (LCDv_HORIZONTAL_DISPLAY_PERIOD);
	*DE_START         = (LCDv_VERTICAL_BACK_PORCH << 16) | (LCDv_HORIZONTAL_BACK_PORCH);
	*GRA_VSYNC_TIM    = 0;

	/* OtBbNX1  */
	*GRCMEN1      = 0x00000002;	/* JgCAʃC[s */
	*GRCBUSCNT1   = 0x00000000;	/* RGB565 */
	*GROPSADR1    = GRA1_VRAM_BASE;
	*GROPSWH1     = (GRA1v_VERTICAL_SIZE << 16) | (GRA1v_HORIZONTAL_SIZE);
	*GROPSOFST1   = GRA1v_HORIZONTAL_SIZE * 2;
	*GROPDPHV1    = ((LCDv_VERTICAL_BACK_PORCH - 1 + GRA1_VERTICAL_POS) << 16)
	                    | (LCDv_HORIZONTAL_BACK_PORCH - 16 + GRA1_HORIZONTAL_POS);
	*GROPBASERGB1 = 0x0000FFFF;	/* OtBbNX摜OF(White) */
	*GRCMEN1      = *GRCMEN1 | (1 << 31);	/* WX^l] */

	/* OtBbNX2  */
	*GRCMEN2      = 0x00000001;	/* JgCsAʃC[ */
	*GRCMEN2      = *GRCMEN2 | (1 << 31);	/* WX^l] */

	/* OtBbNX1 `(J[o[) */
	gra_vram = GRA1_VRAM_BASE;
	for(j = 0; j < GRA1v_VERTICAL_SIZE / 4; j++)
	{
		for(i = 0; i < GRA1v_HORIZONTAL_SIZE; i++)
		{
			if(i < GRA1v_HORIZONTAL_SIZE / 8)
				*gra_vram++ = 0x0000;	/* Black */
			else if(i < GRA1v_HORIZONTAL_SIZE / 8 * 2)
				*gra_vram++ = 0xFFFF;	/* White */
			else if(i < GRA1v_HORIZONTAL_SIZE / 8 * 3)
				*gra_vram++ = 0x07E0;	/* Green */
			else if(i < GRA1v_HORIZONTAL_SIZE / 8 * 4)
				*gra_vram++ = 0x07FF;	/* Cyan */
			else if(i < GRA1v_HORIZONTAL_SIZE / 8 * 5)
				*gra_vram++ = 0xF800;	/* Red */
			else if(i < GRA1v_HORIZONTAL_SIZE / 8 * 6)
				*gra_vram++ = 0xF81F;	/* Magenta */
			else if(i < GRA1v_HORIZONTAL_SIZE / 8 * 7)
				*gra_vram++ = 0xFFE0;	/* Yellow */
			else
				*gra_vram++ = 0x001F;	/* Blue */
		}
	}
	l=0;
	for(j = 0; j < GRA1v_VERTICAL_SIZE / 2; j++)
	{
		for(i = 0; i < GRA1v_HORIZONTAL_SIZE; i++)
		{
			*gra_vram++ = l++;
		}
	}
	for(j = 0; j < GRA1v_VERTICAL_SIZE / 4; j++)
	{
		for(i = 0; i < GRA1v_HORIZONTAL_SIZE; i++)
		{
			*gra_vram++ = (((i & 0xF8) >> 3) << 11)
			            | (((i & 0xFC) >> 2) << 5)
			            |  ((i & 0xF8) >> 3);
		}
	}

	/* [c */
	gra_vram = GRA1_VRAM_BASE;
	for(j = 0; j < GRA1v_VERTICAL_SIZE; j++){
		*gra_vram = 0xFFFF;
		gra_vram = gra_vram + GRA1v_HORIZONTAL_SIZE;
	}

	/* E[c */
	gra_vram = GRA1_VRAM_BASE + ((GRA1v_HORIZONTAL_SIZE-1)*2);
	for(j = 0; j < GRA1v_VERTICAL_SIZE; j++){
		*gra_vram = 0xFFFF;
		gra_vram = gra_vram + GRA1v_HORIZONTAL_SIZE;
	}

	/* [c */
	gra_vram = GRA1_VRAM_BASE;
	for(j = 0; j < GRA1v_HORIZONTAL_SIZE; j++){
		*gra_vram++ = 0xFFFF;
	}

	/* [c */
	gra_vram = GRA1_VRAM_BASE + (GRA1v_HORIZONTAL_SIZE * (GRA1v_VERTICAL_SIZE - 1) * 2);
	for(j = 0; j < GRA1v_HORIZONTAL_SIZE; j++){
		*gra_vram++ = 0xFFFF;
	}

	t_getch();
}

/* SVGA\eXg(800x600) */
void VDC3_SVGA(void)
{
	int i, j, l;
	unsigned short int *gra_vram;

	/* \䕔  */
	*SGMODE           = 0x00000001;
	*SYNCNT           = 0x010F000C;
	*PANEL_CLKSEL     = *PANEL_CLKSEL & ~(1 << 12);
//	*PANEL_CLKSEL     = 0x00002008;		/* 6MHz(48MHz / 8)  6.4MHz(typ) */
	*PANEL_CLKSEL     = 0x00000001;		/* ONbN / 48MHz(48MHz / 1) */
	*PANEL_CLKSEL     = *PANEL_CLKSEL | (1 << 12);
	*SYN_SIZE         = (LCDz_VERTICAL_PERIOD << 16) | (LCDz_HORIZONTAL_PERIOD);
	*PANEL_VSYNC_TIM  = (0 << 16) | (LCDz_VERTICAL_PULSE_WIDTH);
	*PANEL_HSYNC_TIM  = (0 << 16) | (LCDz_HORIZONTAL_PULSE_WIDTH);
	*DE_SIZE          = (LCDz_VERTICAL_DISPLAY_PERIOD << 16) | (LCDz_HORIZONTAL_DISPLAY_PERIOD);
	*DE_START         = (LCDz_VERTICAL_BACK_PORCH << 16) | (LCDz_HORIZONTAL_BACK_PORCH);
	*GRA_VSYNC_TIM    = 0;

	/* OtBbNX1  */
	*GRCMEN1      = 0x00000002;	/* JgCAʃC[s */
	*GRCBUSCNT1   = 0x00000000;	/* RGB565 */
	*GROPSADR1    = GRA1_VRAM_BASE;
	*GROPSWH1     = (GRA1s_VERTICAL_SIZE << 16) | (GRA1s_HORIZONTAL_SIZE);
	*GROPSOFST1   = GRA1s_HORIZONTAL_SIZE * 2;
	*GROPDPHV1    = ((LCDz_VERTICAL_BACK_PORCH - 1 + GRA1_VERTICAL_POS) << 16)
	                    | (LCDz_HORIZONTAL_BACK_PORCH - 16 + GRA1_HORIZONTAL_POS);
	*GROPBASERGB1 = 0x0000FFFF;	/* OtBbNX摜OF(White) */
	*GRCMEN1      = *GRCMEN1 | (1 << 31);	/* WX^l] */

	/* OtBbNX2  */
	*GRCMEN2      = 0x00000001;	/* JgCsAʃC[ */
	*GRCMEN2      = *GRCMEN2 | (1 << 31);	/* WX^l] */

	/* OtBbNX1 `(J[o[) */
	gra_vram = GRA1_VRAM_BASE;
	for(j = 0; j < GRA1s_VERTICAL_SIZE / 4; j++)
	{
		for(i = 0; i < GRA1s_HORIZONTAL_SIZE; i++)
		{
			if(i < GRA1s_HORIZONTAL_SIZE / 8)
				*gra_vram++ = 0x0000;	/* Black */
			else if(i < GRA1s_HORIZONTAL_SIZE / 8 * 2)
				*gra_vram++ = 0xFFFF;	/* White */
			else if(i < GRA1s_HORIZONTAL_SIZE / 8 * 3)
				*gra_vram++ = 0x07E0;	/* Green */
			else if(i < GRA1s_HORIZONTAL_SIZE / 8 * 4)
				*gra_vram++ = 0x07FF;	/* Cyan */
			else if(i < GRA1s_HORIZONTAL_SIZE / 8 * 5)
				*gra_vram++ = 0xF800;	/* Red */
			else if(i < GRA1s_HORIZONTAL_SIZE / 8 * 6)
				*gra_vram++ = 0xF81F;	/* Magenta */
			else if(i < GRA1s_HORIZONTAL_SIZE / 8 * 7)
				*gra_vram++ = 0xFFE0;	/* Yellow */
			else
				*gra_vram++ = 0x001F;	/* Blue */
		}
	}
	l=0;
	for(j = 0; j < GRA1s_VERTICAL_SIZE / 2; j++)
	{
		for(i = 0; i < GRA1s_HORIZONTAL_SIZE; i++)
		{
			*gra_vram++ = l++;
		}
	}
	for(j = 0; j < GRA1s_VERTICAL_SIZE / 4; j++)
	{
		for(i = 0; i < GRA1s_HORIZONTAL_SIZE; i++)
		{
			*gra_vram++ = (((i & 0xF8) >> 3) << 11)
			            | (((i & 0xFC) >> 2) << 5)
			            |  ((i & 0xF8) >> 3);
		}
	}

	/* [c */
	gra_vram = GRA1_VRAM_BASE;
	for(j = 0; j < GRA1s_VERTICAL_SIZE; j++){
		*gra_vram = 0xFFFF;
		gra_vram = gra_vram + GRA1s_HORIZONTAL_SIZE;
	}

	/* E[c */
	gra_vram = GRA1_VRAM_BASE + ((GRA1s_HORIZONTAL_SIZE-1)*2);
	for(j = 0; j < GRA1s_VERTICAL_SIZE; j++){
		*gra_vram = 0xFFFF;
		gra_vram = gra_vram + GRA1s_HORIZONTAL_SIZE;
	}

	/* [c */
	gra_vram = GRA1_VRAM_BASE;
	for(j = 0; j < GRA1s_HORIZONTAL_SIZE; j++){
		*gra_vram++ = 0xFFFF;
	}

	/* [c */
	gra_vram = GRA1_VRAM_BASE + (GRA1s_HORIZONTAL_SIZE * (GRA1s_VERTICAL_SIZE - 1) * 2);
	for(j = 0; j < GRA1s_HORIZONTAL_SIZE; j++){
		*gra_vram++ = 0xFFFF;
	}

	t_getch();
}

/* SVGA\eXg(768x600) */
void VDC3_SVGAz(void)
{
	int i, j, l;
	unsigned short int *gra_vram;

	/* \䕔  */
	*SGMODE           = 0x00000001;
	*SYNCNT           = 0x010F000C;
	*PANEL_CLKSEL     = *PANEL_CLKSEL & ~(1 << 12);
//	*PANEL_CLKSEL     = 0x00002008;		/* 6MHz(48MHz / 8)  6.4MHz(typ) */
	*PANEL_CLKSEL     = 0x00000001;		/* ONbN / 48MHz(48MHz / 1) */
	*PANEL_CLKSEL     = *PANEL_CLKSEL | (1 << 12);
	*SYN_SIZE         = (LCDs_VERTICAL_PERIOD << 16) | (LCDs_HORIZONTAL_PERIOD);
	*PANEL_VSYNC_TIM  = (0 << 16) | (LCDs_VERTICAL_PULSE_WIDTH);
	*PANEL_HSYNC_TIM  = (0 << 16) | (LCDs_HORIZONTAL_PULSE_WIDTH);
	*DE_SIZE          = (LCDs_VERTICAL_DISPLAY_PERIOD << 16) | (LCDs_HORIZONTAL_DISPLAY_PERIOD);
	*DE_START         = (LCDs_VERTICAL_BACK_PORCH << 16) | (LCDs_HORIZONTAL_BACK_PORCH);
	*GRA_VSYNC_TIM    = 0;

	/* OtBbNX1  */
	*GRCMEN1      = 0x00000002;	/* JgCAʃC[s */
	*GRCBUSCNT1   = 0x00000000;	/* RGB565 */
	*GROPSADR1    = GRA1_VRAM_BASE;
	*GROPSWH1     = (GRA1s_VERTICAL_SIZE << 16) | (GRA1s_HORIZONTAL_SIZE);
	*GROPSOFST1   = GRA1s_HORIZONTAL_SIZE * 2;
	*GROPDPHV1    = ((LCDs_VERTICAL_BACK_PORCH - 1 + GRA1_VERTICAL_POS) << 16)
	                    | (LCDs_HORIZONTAL_BACK_PORCH - 16 + GRA1_HORIZONTAL_POS);
	*GROPBASERGB1 = 0x0000FFFF;	/* OtBbNX摜OF(White) */
	*GRCMEN1      = *GRCMEN1 | (1 << 31);	/* WX^l] */

	/* OtBbNX2  */
	*GRCMEN2      = 0x00000001;	/* JgCsAʃC[ */
	*GRCMEN2      = *GRCMEN2 | (1 << 31);	/* WX^l] */

	/* OtBbNX1 `(J[o[) */
	gra_vram = GRA1_VRAM_BASE;
	for(j = 0; j < GRA1s_VERTICAL_SIZE / 4; j++)
	{
		for(i = 0; i < GRA1s_HORIZONTAL_SIZE; i++)
		{
			if(i < GRA1s_HORIZONTAL_SIZE / 8)
				*gra_vram++ = 0x0000;	/* Black */
			else if(i < GRA1s_HORIZONTAL_SIZE / 8 * 2)
				*gra_vram++ = 0xFFFF;	/* White */
			else if(i < GRA1s_HORIZONTAL_SIZE / 8 * 3)
				*gra_vram++ = 0x07E0;	/* Green */
			else if(i < GRA1s_HORIZONTAL_SIZE / 8 * 4)
				*gra_vram++ = 0x07FF;	/* Cyan */
			else if(i < GRA1s_HORIZONTAL_SIZE / 8 * 5)
				*gra_vram++ = 0xF800;	/* Red */
			else if(i < GRA1s_HORIZONTAL_SIZE / 8 * 6)
				*gra_vram++ = 0xF81F;	/* Magenta */
			else if(i < GRA1s_HORIZONTAL_SIZE / 8 * 7)
				*gra_vram++ = 0xFFE0;	/* Yellow */
			else
				*gra_vram++ = 0x001F;	/* Blue */
		}
	}
	l=0;
	for(j = 0; j < GRA1s_VERTICAL_SIZE / 2; j++)
	{
		for(i = 0; i < GRA1s_HORIZONTAL_SIZE; i++)
		{
			*gra_vram++ = l++;
		}
	}
	for(j = 0; j < GRA1s_VERTICAL_SIZE / 4; j++)
	{
		for(i = 0; i < GRA1s_HORIZONTAL_SIZE; i++)
		{
			*gra_vram++ = (((i & 0xF8) >> 3) << 11)
			            | (((i & 0xFC) >> 2) << 5)
			            |  ((i & 0xF8) >> 3);
		}
	}

	/* [c */
	gra_vram = GRA1_VRAM_BASE;
	for(j = 0; j < GRA1s_VERTICAL_SIZE; j++){
		*gra_vram = 0xFFFF;
		gra_vram = gra_vram + GRA1s_HORIZONTAL_SIZE;
	}

	/* E[c */
	gra_vram = GRA1_VRAM_BASE + ((GRA1s_HORIZONTAL_SIZE-1)*2);
	for(j = 0; j < GRA1s_VERTICAL_SIZE; j++){
		*gra_vram = 0xFFFF;
		gra_vram = gra_vram + GRA1s_HORIZONTAL_SIZE;
	}

	/* [c */
	gra_vram = GRA1_VRAM_BASE;
	for(j = 0; j < GRA1s_HORIZONTAL_SIZE; j++){
		*gra_vram++ = 0xFFFF;
	}

	/* [c */
	gra_vram = GRA1_VRAM_BASE + (GRA1s_HORIZONTAL_SIZE * (GRA1s_VERTICAL_SIZE - 1) * 2);
	for(j = 0; j < GRA1s_HORIZONTAL_SIZE; j++){
		*gra_vram++ = 0xFFFF;
	}

	t_getch();
}

int main(void)
{
	/* CPU  */
	CPU_BusInitialize();

	/* R\[(UART) */
	CPU_UartInitialize();
	CPU_UartPuts("\n\nLCD sample\n");

	/* VDC3  */
	*PGCR7 = 0x5A01;	/* LCD_DATA0 */
	*PGCR5 = (*PGCR5 & 0xFFF0) | 1;	/* LCD_EXTCLK */
	*PGCR4 = 0x1111;	/* LCD_CLK, LCD_DE, LCD_HSYNC, LCD_VSYNC */
	*PGCR3 = 0x1111;	/* LCD_DATA15-12 */
	*PGCR2 = 0x1111;	/* LCD_DATA11-8 */
	*PGCR1 = 0x1111;	/* LCD_DATA7-4 */
	*PGCR0 = 0x1110;	/* LCD_DATA3-1 */

	*STBCR7 = *STBCR7 & ~(1 << 4);	/* VDC3ւ̃NbN */

	while(1){
		CPU_UartPuts("\nVGA mode ...");
		VDC3_VGA();
		CPU_UartPuts("\nSVGA(800x600) mode ...");
		VDC3_SVGA();
		CPU_UartPuts("\nSVGA(768x600) mode ...");
		VDC3_SVGAz();
	}
}
